From fa37e8b2dd03967c6a9d7e2994a9db05045814cf Mon Sep 17 00:00:00 2001
From: Prabhakara Rao Pediredla <ppedired@codeaurora.org>
Date: Thu, 5 Oct 2017 22:24:30 +0530
Subject: [PATCH] 8996-gvm: init crash fix due to Treble changes with sepolicy

Handled device name , partition name properly.

Change-Id: Ie56b794bed6a9f6b005d66977a859d02520b5a6f
---
 init/init_first_stage.cpp   | 12 ++++++++++++
 rootdir/init.rc             | 20 --------------------
 rootdir/init.zygote32.rc    |  2 +-
 rootdir/init.zygote32_64.rc |  2 +-
 rootdir/init.zygote64.rc    |  2 +-
 rootdir/init.zygote64_32.rc |  2 +-
 6 files changed, 16 insertions(+), 24 deletions(-)

diff --git a/init/init_first_stage.cpp b/init/init_first_stage.cpp
index bcc8d1b..3029f93 100644
--- a/init/init_first_stage.cpp
+++ b/init/init_first_stage.cpp
@@ -202,6 +202,18 @@ coldboot_action_t FirstStageMount::ColdbootCallback(uevent* uevent) {
                 return COLDBOOT_CREATE;  // Creates this device and continue to find others.
             }
         }
+    } else if (uevent->device_name) {
+        // Matches device name to create device nodes.
+        auto iter = required_devices_partition_names_.find(uevent->device_name);
+        if (iter != required_devices_partition_names_.end()) {
+            LOG(VERBOSE) << __FUNCTION__ << "(): found device: " << *iter;
+            required_devices_partition_names_.erase(iter);
+            if (required_devices_partition_names_.empty()) {
+                return COLDBOOT_STOP;  // Found all devices, stop coldboot.
+            } else {
+                return COLDBOOT_CREATE;  // Creates this device and continue to find others.
+            }
+        }
     }
     // Not found a partition or find an unneeded partition, continue to find others.
     return COLDBOOT_CONTINUE;
diff --git a/rootdir/init.rc b/rootdir/init.rc
index d52bfa7..242fbc1 100644
--- a/rootdir/init.rc
+++ b/rootdir/init.rc
@@ -502,26 +502,6 @@ on post-fs-data
 
 # It is recommended to put unnecessary data/ initialization from post-fs-data
 # to start-zygote in device's init.rc to unblock zygote start.
-on zygote-start && property:ro.crypto.state=unencrypted
-    # A/B update verifier that marks a successful boot.
-    exec_start update_verifier_nonencrypted
-    start netd
-    start zygote
-    start zygote_secondary
-
-on zygote-start && property:ro.crypto.state=unsupported
-    # A/B update verifier that marks a successful boot.
-    exec_start update_verifier_nonencrypted
-    start netd
-    start zygote
-    start zygote_secondary
-
-on zygote-start && property:ro.crypto.state=encrypted && property:ro.crypto.type=file
-    # A/B update verifier that marks a successful boot.
-    exec_start update_verifier_nonencrypted
-    start netd
-    start zygote
-    start zygote_secondary
 
 on boot
     # basic network init
diff --git a/rootdir/init.zygote32.rc b/rootdir/init.zygote32.rc
index d836c4e..c4fb4ec 100644
--- a/rootdir/init.zygote32.rc
+++ b/rootdir/init.zygote32.rc
@@ -9,6 +9,6 @@ service zygote /system/bin/app_process -Xzygote /system/bin --zygote --start-sys
     onrestart restart audioserver
     onrestart restart cameraserver
     onrestart restart media
-    onrestart restart netd
+    # onrestart restart netd
     onrestart restart wificond
     writepid /dev/cpuset/foreground/tasks
diff --git a/rootdir/init.zygote32_64.rc b/rootdir/init.zygote32_64.rc
index 80bb673..be92f06 100644
--- a/rootdir/init.zygote32_64.rc
+++ b/rootdir/init.zygote32_64.rc
@@ -9,7 +9,7 @@ service zygote /system/bin/app_process32 -Xzygote /system/bin --zygote --start-s
     onrestart restart audioserver
     onrestart restart cameraserver
     onrestart restart media
-    onrestart restart netd
+    # onrestart restart netd
     onrestart restart wificond
     writepid /dev/cpuset/foreground/tasks
 
diff --git a/rootdir/init.zygote64.rc b/rootdir/init.zygote64.rc
index 05ec16f..f667c9a 100644
--- a/rootdir/init.zygote64.rc
+++ b/rootdir/init.zygote64.rc
@@ -9,6 +9,6 @@ service zygote /system/bin/app_process64 -Xzygote /system/bin --zygote --start-s
     onrestart restart audioserver
     onrestart restart cameraserver
     onrestart restart media
-    onrestart restart netd
+    # onrestart restart netd
     onrestart restart wificond
     writepid /dev/cpuset/foreground/tasks
diff --git a/rootdir/init.zygote64_32.rc b/rootdir/init.zygote64_32.rc
index 09db7b0..5ad72c0 100644
--- a/rootdir/init.zygote64_32.rc
+++ b/rootdir/init.zygote64_32.rc
@@ -9,7 +9,7 @@ service zygote /system/bin/app_process64 -Xzygote /system/bin --zygote --start-s
     onrestart restart audioserver
     onrestart restart cameraserver
     onrestart restart media
-    onrestart restart netd
+    # onrestart restart netd
     onrestart restart wificond
     writepid /dev/cpuset/foreground/tasks
 
-- 
1.9.1

